Osmocom primitives

## Files

file | prim.h

## Data Structures

struct | osmo_prim_hdr
| primitive header More...

## Macros

#define | OSMO_PRIM(prim, op) ((prim << 8) | (op & 0xFF))
#define | OSMO_PRIM_HDR(oph) OSMO_PRIM((oph)->primitive, (oph)->operation)
#define | _SAP_GSM_SHIFT 24
#define | _SAP_GSM_BASE (0x01 << _SAP_GSM_SHIFT)
#define | _SAP_TETRA_BASE (0x02 << _SAP_GSM_SHIFT)

## Typedefs

typedef int(* | osmo_prim_cb) (struct osmo_prim_hdr *oph, void *ctx)
| primitive handler callback type

## Enumerations

enum | osmo_prim_operation { PRIM_OP_REQUEST, PRIM_OP_RESPONSE, PRIM_OP_INDICATION, PRIM_OP_CONFIRM }
| primitive operation More...

## Functions

static void | osmo_prim_init (struct osmo_prim_hdr *oph, unsigned int sap, unsigned int primitive, enum osmo_prim_operation operation, struct msgb *msg)
| initialize a primitive header More...

## Detailed Description

## Enumeration Type Documentation

## osmo_prim_operation

enum osmo_prim_operation

primitive operation

Enumerator
PRIM_OP_REQUEST | request
PRIM_OP_RESPONSE | response
PRIM_OP_INDICATION | indication
PRIM_OP_CONFIRM | cofirm

## Function Documentation

## osmo_prim_init()

static void osmo_prim_init | ( | struct osmo_prim_hdr * | oph,
|  | unsigned int | sap,
|  | unsigned int | primitive,
|  | enum osmo_prim_operation | operation,
|  | struct msgb * | msg
| ) |  |

inline static

initialize a primitive header

Parameters

  [in,out] | oph | primitive header
  [in] | sap | Service Access Point
  [in] | primitive | Primitive Number
  [in] | operation | Primitive Operation (REQ/RESP/IND/CONF)
  [in] | msg | Message

References osmo_prim_hdr::msg, osmo_prim_hdr::primitive, and osmo_prim_hdr::sap.